package com.diagbot.repository;


import com.diagbot.entity.node.ExportRelation;
import com.diagbot.entity.node.ExportRelationInfo;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;

import java.util.List;

public interface ExportRelationRepository extends Neo4jRepository<ExportRelationInfo, Long> {

    @Query("MATCH (c:药品化学物质类别)<-[r:药品相关药品化学物质类别]-(y:药品代码通用名)-[r1:药品相关药品通用名称]->(m:药品通用名称)  RETURN DISTINCT trim(c.name) as sname,trim(m.name) as ename")
    List<ExportRelation> getDrugRelationA();

    @Query("MATCH (c:药品治疗学类别)<-[r:药品相关药品治疗学类别]-(y:药品代码通用名)-[r1:药品相关药品通用名称]->(m:药品通用名称)  RETURN DISTINCT trim(c.name) as sname,trim(m.name) as ename")
    List<ExportRelation> getDrugRelationB();

    @Query("MATCH (c:药品药理学类别)<-[r:药品相关药品药理学类别]-(y:药品代码通用名)-[r1:药品相关药品通用名称]->(m:药品通用名称)  RETURN DISTINCT trim(c.name) as sname,trim(m.name) as ename")
    List<ExportRelation> getDrugRelationC();

    @Query("MATCH (c:药品解剖学类别)<-[r:药品相关药品解剖学类别]-(y:药品代码通用名)-[r1:药品相关药品通用名称]->(m:药品通用名称)  RETURN DISTINCT trim(c.name) as sname,trim(m.name) as ename")
    List<ExportRelation> getDrugRelationD();

    @Query("MATCH (n:`实验室检查套餐名`)<-[r:实验室检查名称相关实验室检查套餐名]-(m:`实验室检查名称`) RETURN DISTINCT trim(n.name) as sname,trim(m.name) as ename")
    List<ExportRelation> getLisRelation();

    @Query("MATCH (n:`辅助检查名称`)-[r:辅助检查名称包含辅助检查子项目名称]->(m:`辅助检查子项目名称`) RETURN DISTINCT trim(n.name) as sname,trim(m.name) as ename")
    List<ExportRelation> getPacsRelation();
}