package com.diagbot.web;

import com.diagbot.dto.RespDTO;
import com.diagbot.facade.ExportFacade;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description:
 * @author: gaodm
 * @time: 2021/1/21 9:37
 */
@RestController
@RequestMapping("/export")
@Api(value = "图谱数据迁移相关API", tags = { "图谱数据迁移相关API" })
@SuppressWarnings("unchecked")
public class ExportController {
    @Autowired
    private ExportFacade exportFacade;

    @ApiOperation(value = "图谱数据节点迁移[gaodm]",
            notes = "")
    @PostMapping("/gdbExportNode")
    public RespDTO<Boolean> gdbExportNode() {
        return RespDTO.onSuc(exportFacade.gdbExportNode());
    }

    @ApiOperation(value = "图谱数据关系迁移[gaodm]",
            notes = "")
    @PostMapping("/gdbExportRelation")
    public RespDTO<Boolean> gdbExportRelation() {
        return RespDTO.onSuc(exportFacade.gdbExportRelation());
    }
}
